<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsresource11 extends JPlugin
{
	function plgAnalyticsresource11( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) 
	{
		if ( $name != 'resource11' ) return;
		
		$data = array( 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
			
		if($name != 'resource11') return;

		global $mainframe;

		if( !JComponentHelper::isEnabled('com_resource', true) ) {
			$errors = '<h3>Mighty Resources Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->setConfig('column.data_labels','<![CDATA[{value}]]>');
		$objChart->addLabel("<![CDATA[<b>Top articles by types</b>]]>",15 ,25 , array('text_size' => 16));
		
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'resource11' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label" '.($key == 'category' ? 'valign="top"' : '').'><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{

		if($name != 'resource11') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$type       = $params->get( 'types' );
		$categories = $params->get( 'cats' );
		$criterion  = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$max        = $params->get( 'max', 20 );
		$reverse    = $params->get( 'reverse', 'DESC' );

		if( !$type ) return;
		if( !$categories ) return;
		if( !$criterion ) return;

		if( !is_array( $type ) ) {
			$type = Array( $type );
		}

		if( !is_array( $categories ) ) {
			$categories = Array( $categories );
		}

		switch( $criterion ) {
			case 'rating_average':
				$sql = "     SELECT (SUM(v.vote)/COUNT(*))   AS amount,  t.name AS title, t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND v.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				."\n      LIMIT 0, ".$max
				;
				break;
			case 'rating_count':
				$sql = "     SELECT COUNT(distinct v.id)   AS amount, t.name AS title,  t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND v.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= "  GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				."\n      LIMIT 0, ".$max
				;
				break;
			case 'comments':
				$sql = "     SELECT COUNT(distinct co.id)   AS amount,   t.name AS title,      t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_comments        AS co ON co.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND co.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= "  GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				."\n      LIMIT 0, ".$max
				;
				break;
			case 'favorite':
				$sql = "     SELECT COUNT(*)     AS amount,      t.name AS title,  t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_favorite        AS f  ON f.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND f.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				."\n      LIMIT 0, ".$max
				;
				break;
			case 'hits':
				$sql = "     SELECT COUNT(distinct h.id)   AS amount,   t.name AS title,   t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_hits            AS h  ON h.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND h.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				."\n      LIMIT 0, ".$max
				;
				break;
					
		}

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		foreach ( $result AS $row ) {
				$objChart->addSerie($row->id,$row->title);
				$objChart->addGraph($row->id, $row->title, array($row->id => $row->amount), array( 
						'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
					));
		}

	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'resource11') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$type       = $params->get( 'types' );
		$categories = $params->get( 'cats' );
		$criterion  = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$max        = $params->get( 'max', 20 );
		$reverse    = $params->get( 'reverse', 'DESC' );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		if( !$type ) return;
		if( !$categories ) return;
		if( !$criterion ) return;

		if( !is_array( $type ) ) {
			$type = Array( $type );
		}

		if( !is_array( $categories ) ) {
			$categories = Array( $categories );
		}

		switch( $criterion ) {
			case 'rating_average':
				$sql = "     SELECT (SUM(v.vote)/COUNT(*))   AS amount, t.name AS title,  t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND v.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= "  GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				;
				break;
			case 'rating_count':
				$sql = "     SELECT COUNT(distinct v.id)   AS amount,    t.name AS title,  t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND v.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				;
				break;
			case 'comments':
				$sql = "     SELECT COUNT(distinct co.id)   AS amount,   t.name AS title,  t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_comments        AS co ON co.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND co.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				;
				break;
			case 'favorite':
				$sql = "     SELECT COUNT(*)    AS amount,    t.name AS title,   t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_favorite        AS f  ON f.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND f.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				;
				break;
			case 'hits':
				$sql = "     SELECT COUNT(distinct h.id)    AS amount,     t.name AS title,    t.id"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_hits            AS h  ON h.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND h.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY t.id"
				."\n   ORDER BY amount ".$reverse
				;
				break;
					
		}
		if ( $limit )
		$sql .= " LIMIT 0, $limit";
		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		$k                  = 0;
		$current_total      = 0;

		$data_label = array( 'rating_average' => JText::_('Rating (avarage)'),
		                     'rating_count'   => JText::_('Rating (count)'),
		                     'comments'       => JText::_('Comments'),
		                     'favorite'       => JText::_('Favorite'),
		                     'hits'           => JText::_('HITs') );

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Type').'</th>';
		$out[] = '<th width="1%">'.$data_label[$criterion].'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		foreach ( $result AS $row ) {
			$slices[$row->id]['name'] = $row->title;
			$slices[$row->id]['amount'] = $row->amount;
		}

		$k = 1;
		$i = 1;
		foreach ( $slices AS $key => $slice ) {

			$current_total += $slice['amount'];

			$k = 1 - $k;

			$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
			$k, $i, $slice['name'], $slice['amount']
			);
			$i++;
		}

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}

	}

	function onGetTotals($name, $params)
	{
		if($name != 'resource11') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$type       = $params->get( 'types' );
		$categories = $params->get( 'cats' );
		$criterion  = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$max        = $params->get( 'max', 20 );
		$reverse    = $params->get( 'reverse', 'DESC' );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		if( !$type ) return;
		if( !$categories ) return;
		if( !$criterion ) return;

		if( !is_array( $type ) ) {
			$type = Array( $type );
		}

		if( !is_array( $categories ) ) {
			$categories = Array( $categories );
		}

		switch( $criterion ) {
			case 'rating_average':
				$sql = "     SELECT (SUM(v.vote)/COUNT(v.id))   AS amount , count(distinct r.id) AS rec_count"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND v.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				
				$sql_total = "     SELECT (SUM(v.vote)/COUNT(v.id))   AS amount "
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				
				break;
			case 'rating_count':
				$sql = "     SELECT COUNT(distinct v.id)   AS amount , count(distinct r.id) AS rec_count"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND v.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				
				$sql_total = "     SELECT COUNT(distinct v.id)   AS amount "
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				
				break;
			case 'comments':
				$sql = "     SELECT COUNT(distinct co.id)   AS amount , count(distinct r.id) AS rec_count"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_comments        AS co ON co.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND co.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
					
				$sql_total = "     SELECT COUNT(distinct co.id)   AS amount "
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_comments        AS co ON co.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				
				break;
			case 'favorite':
				$sql = "     SELECT COUNT(*)    AS amount , count(distinct r.id) AS rec_count"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_favorite        AS f  ON f.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND f.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
					
				$sql_total = "     SELECT COUNT(*)    AS amount "
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_favorite        AS f  ON f.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				
				break;
			case 'hits':
				$sql = "     SELECT COUNT(distinct h.id)    AS amount , count(distinct r.id) AS rec_count"
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_hits            AS h  ON h.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')
				AND h.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
					
				$sql_total = "     SELECT COUNT(distinct h.id)    AS amount "
				."\n       FROM #__js_res_types           AS t"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.type_id = t.id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
				."\n  LEFT JOIN #__js_res_category        AS c  ON c.id = rc.catid"
				."\n  LEFT JOIN #__js_res_hits            AS h  ON h.record_id = r.id"
				."\n      WHERE t.id IN('".implode( "', '", $type )."') AND c.id IN('".implode( "', '", $categories )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				
				break;
					
		}
		$sql .= " LIMIT 0, $max";
		
		$db->setQuery( $sql );		
		$result = $db->loadObject();
		
		if(!$result) return;
		
		$db->setQuery( $sql_total ); 
		$total = $db->loadResult();
		
		$sql2 = "SELECT COUNT(*) FROM #__js_res_record r
		LEFT JOIN #__js_res_record_category rc ON r.id = rc.record_id
		WHERE r.type_id IN('".implode( "', '", $type )."') AND rc.catid IN ( ".implode(', ', $categories)." ) AND r.published = 1 ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql2 .= " AND r.user_id = '$user_id'";
		
		$db->setQuery( $sql2 ); 
		$dbtotal_records = $db->loadResult();
		
		if(!$dbtotal_records) return;
		
		$totals = array();

		$data_label = array( 'rating_average' => JText::_('rating (avarage)'),
		                     'rating_count'   => JText::_('rating (count)'),
		                     'comments'       => JText::_('comments'),
		                     'favorite'       => JText::_('favorite'),
		                     'hits'           => JText::_('hits') );
		$text = $data_label[$criterion];

		$totals[0]['value'] = $dbtotal_records.' <i>'.JText::_( 'record(s)').'</i>';
		$totals[0]['text'] = JText::_('Total in DB');
		
		$totals[1]['value'] = $result->rec_count.' <i><b>'.JText::_( 'current record(s)' ).'</b></i>';
		$totals[1]['text'] = round($result->rec_count * 100 / $dbtotal_records, 1).'% '.JText::_('of all records');
		
		$totals[2]['value'] = $total;
		$totals[2]['text'] = JText::_('Total').' '.$text;
		
		$totals[3]['value'] = $result->amount.' <i><b>'.JText::_( 'current' ).' '.$text.'</b></i>';
		$totals[3]['text'] = round($result->amount * 100 / $total, 1).'% '.JText::_('of all').' '.$text;
		
		return $totals;
	}
}
?>