<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsresource13 extends JPlugin
{
	function plgAnalyticsresource13( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) 
	{
		if($name != 'resource13') return;
		
		$data = array('amline','ampie','amcolumn');
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'resource13' ) return;
		
		if( !$params->get('user_stick') ){
			$form .= '<h3>'.JText::_('This report must be user strict').'</h3>';
			return;
		}
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		$form .= '<tr>';

		if ($elements['sections'][0]) {
			$form .= '<td class="label" valign="top"><span class="editlinktip">'.$elements['sections'][0].'</span></td>';
			$form .= '<td class="inputbox field" valign="top">'.$elements['sections'][1].'</td>';
		} else {
			$form .= '<td class="inputbox field" colspan="2">'.$elements['sections'][1].'</td>';
		}
		unset($elements['sections']);
		
		if ($elements['articles'][0]) {
			$form .= '<td class="label" valign="top"><span class="editlinktip">'.$elements['articles'][0].'</span></td>';
			$form .= '<td class="inputbox field" valign="top">'.$elements['articles'][1].'</td>';
		} else {
			$form .= '<td class="inputbox field" colspan="2">'.$elements['articles'][1].'</td>';
		}
		unset($elements['articles']);

		$form .= '</tr>';

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';

	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if($name != 'resource13') return;

		global $mainframe;

		if( !JComponentHelper::isEnabled('com_resource', true) ) {
			$errors = '<h3>Mighty Resources Component Not Exists or Not Enabled<h3>';
			return;
		}
		
		if( !JComponentHelper::isEnabled('com_juser', true) ) {
			$errors = '<h3>Mighty Registration Component Not Exists or Not Enabled<h3>';
			return;
		}
		
		$mparams = JComponentHelper::getParams('com_analytics');
		
		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[This graph shows articles & user data interaction]]>",20 ,385 , array('text_size' => 10));
		$objChart->addLabel("<![CDATA[<b>Articles & User data interaction</b>]]>",90 ,25 , array('text_size' => 16));
	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'resource13') return;

		$type = $params->get('chart_type');

		$db = JFactory::getDBO();
		$user = &JFactory::getUser();
		$user_id = $params->get('user_id');
		if(!$params->get('user_stick'))
			return;
			
		$sections  = $params->get( 'sections' );
		$articles = ( is_array($params->get( 'articles' )) ? $params->get( 'articles' ) : array( $params->get( 'articles' ) ) );
		$field = $params->get( 'field' );
		$criterion = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );

		if( !$sections ) return;
		if( empty($articles) || in_array( -1, $articles) ) return;
		if( !$field ) return;
		if( !$criterion ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}

		switch( $criterion ) {
			case 'vote_count':
			case 'vote_average':
				$time_criterion = "v.ctime";
				break;
			case 'comments':
				$time_criterion = "co.ctime";
				break;
			case 'favorite':
				$time_criterion = "f.ctime";
				break;
			case 'hits':
				$time_criterion = "h.ctime";
				break;
					
		}
		
		if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(".$time_criterion.")",
		                   		  "sweek"  => "WEEKOFYEAR(".$time_criterion.")",
								  "smonth" => "MONTH(".$time_criterion.")",
			                      "syear"  => "YEAR(".$time_criterion.")");

			$date_index = Array(  "sday"   => "DATE_FORMAT( ".$time_criterion.", '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( ".$time_criterion." - INTERVAL WEEKDAY(".$time_criterion.") DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( ".$time_criterion.", '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( ".$time_criterion.", '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(".$time_criterion.") AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		switch( $criterion ) {
			case 'vote_average':
				$sql = "     SELECT round( (Sum(v.vote)/COUNT(v.id)), 1 ) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_vote AS v ON v.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = v.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
				  break;
			case 'vote_count':
				$sql = "     SELECT COUNT(distinct v.id) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_vote AS v ON v.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = v.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
				   break;
			case 'comments':
				$sql = "     SELECT COUNT(distinct co.id) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_comments AS co ON co.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = co.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
				    break;
			case 'favorite':
				$sql = "     SELECT COUNT(*) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_favorite AS f ON f.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = f.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
					break;	
			case 'hits':
				$sql = "     SELECT COUNT(distinct h.id) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_hits AS h ON h.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = h.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
					break;
		}

		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if( !$result ) return;

		if ( $type != 'ampie')
		{
			$current_date = $from;
				
			switch ( $groupby ) {
				case "sday":
					$format_series      = '%Y %d %b';
					break;
				case "sweek":
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %UW';
					break;
				case "smonth":
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_description = '%Y %b';
					$format_series      = '%Y %b';
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y';
					break;
			}
			
			foreach ( $result AS $row ) {
				$graphs[$row->name][$row->date_index] = $row->amount;
			}
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$serie       = strftime( $format_series,      strtotime( $current_date ) );
				$objChart->addSerie($current_date,$serie);
				if ( $type == 'amline')
				{
					foreach( $graphs as $key => $graph) {
						if( !isset($graphs[$key][$current_date]) ) {
							$graphs[$key][$current_date] = " 0 ";
							
						}
					}
				}
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
			
			
			foreach( $graphs as $key => $graph ) {
				$objChart->addGraph($key, $key, $graph, array( 
					'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
				));
			} 
	
		} else {
			foreach ( $result AS $row ) {
				$slices[$row->name] = $row->amount;
			}
	
			$i = 0;
			foreach ( $slices AS $k => $slice ) {
	
				$pulout = $i == 0 ? 'true' : 'false';
				$objChart->addSlice($k, $slice, array( 'pull_out' => $pulout, 'alpha' => 95) );
				$i++;
			}
		}

	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'resource13') return;

		$db = JFactory::getDBO();
		$user = &JFactory::getUser();
		$user_id = $params->get('user_id');
		if(!$params->get('user_stick'))
			return;
		
		$type = $params->get('ctype', $params->get('chart_type', 'amcolumn')) ;
		$sections  = $params->get( 'sections' );
		$articles = ( is_array($params->get( 'articles' )) ? $params->get( 'articles' ) : array( $params->get( 'articles' ) ) );
		$field = $params->get( 'field' );
		$criterion = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );
		$limit = $params->get('limit', 0);

		if( !$sections ) return;
		if( empty($articles) || in_array( -1, $articles) ) return;
		if( !$field ) return;
		if( !$criterion ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}

		switch( $criterion ) {
			case 'vote_count':
			case 'vote_average':
				$time_criterion = "v.ctime";
				break;
			case 'comments':
				$time_criterion = "co.ctime";
				break;
			case 'favorite':
				$time_criterion = "f.ctime";
				break;
			case 'hits':
				$time_criterion = "h.ctime";
				break;
					
		}
		
		if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(".$time_criterion.")",
		                   		  "sweek"  => "WEEKOFYEAR(".$time_criterion.")",
								  "smonth" => "MONTH(".$time_criterion.")",
			                      "syear"  => "YEAR(".$time_criterion.")");

			$date_index = Array(  "sday"   => "DATE_FORMAT( ".$time_criterion.", '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( ".$time_criterion." - INTERVAL WEEKDAY(".$time_criterion.") DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( ".$time_criterion.", '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( ".$time_criterion.", '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(".$time_criterion.") AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		switch( $criterion ) {
			case 'vote_average':
				$sql = "     SELECT round( (Sum(v.vote)/COUNT(v.id)), 1 ) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_vote AS v ON v.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = v.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
				  break;
			case 'vote_count':
				$sql = "     SELECT COUNT(distinct v.id) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_vote AS v ON v.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = v.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
				   break;
			case 'comments':
				$sql = "     SELECT COUNT(distinct co.id) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_comments AS co ON co.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = co.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
				    break;
			case 'favorite':
				$sql = "     SELECT COUNT(*) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_favorite AS f ON f.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = f.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
					break;
			case 'hits':
				$sql = "     SELECT COUNT(distinct h.id) AS amount, IF(d.fvalue <> '',d.fvalue,'".mysql_escape_string(JText::_('Anonymous'))."') as name"
					.$sql_dates
				   ."\n FROM #__js_res_record_category AS rc
					Inner Join #__js_res_category AS c ON c.id = rc.catid OR c.section_id = rc.catid
					Inner Join #__js_res_hits AS h ON h.record_id = rc.record_id
					Left Join #__juser_extended_data AS d ON d.user_id = h.user_id AND d.field_id = ".$field
				   ."\n Inner Join #__js_res_record AS r ON r.id = rc.record_id" 
				   ."\n WHERE r.published = 1 AND rc.catid IN('".implode( "', '", $sections )."') ". (!in_array(0,$articles) ? ' AND r.id IN ('. implode(',', $articles).')' : ''  )  ." AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
				   		$sql .= " AND r.user_id = '$user_id'";
				   $sql .= " GROUP BY ".$sql_group." d.fvalue"
				   ;
					break;
		}

		$db->setQuery($sql);
		$result = $db->loadObjectList();

		if( !$result ) return;
		if ( $type != 'ampie')
		{
			foreach ( $result AS $row ) {
				$graphs[$row->name][$row->date_index] = $row->amount;
			}
	
			$k     = 0;
			$total = 0;
	
			$out[] = '<table class="adminlist" cellspacing="0">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			foreach( $graphs as $key => $graph) {
				$out[] = '<th>'.$key.'</th>';
			}
			$out[] = '<th width="1%">'.JText::_('Date').'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			$current_date = $from;
				
			switch ( $groupby ) {
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
	
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
			}
	
			$i = 0;
			while ( strtotime( $current_date ) <= strtotime( $to )) {
				$i++;
				if ( $limit && $i > $limit ) break;
				$k = 1 - $k;
				$out[] = "<tr class='row".$k."'>";
				$out[] = "<td>".$i."</td>";
				foreach( $graphs as $key => $graph) {
					if( !isset($graphs[$key][$current_date]) ) {
						$graphs[$key][$current_date] = 0;
					}
					if( !isset($graphs[$key]['total']) ){
						$graphs[$key]['total'] = 0;
						$graphs[$key]['count'] = 0;
					}
	
					if( $graphs[$key][$current_date] > 0 ) {
						$graphs[$key]['total'] += $graphs[$key][$current_date];
						$graphs[$key]['count'] ++;
					}
	
					$out[] = "<td>".$graphs[$key][$current_date]."</td>";
	
				}
				$out[] = "<td>".$current_date."</td>";
				$out[] = "</tr>";
	
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
			
			$out[] = "<tr class='row".$k."'><td><big><b>".JText::_('Total')."</b></big></td>";
	
			foreach( $graphs as $key => $graph) {
				$out[] = "<td><big><b>".round( ($criterion == 'vote_average' && $graphs[$key]['count'] > 0 ) ? $graphs[$key]['total'] / $graphs[$key]['count'] : $graphs[$key]['total'], 2 )."<b></big></td>";
			}
			$out[] = "<td></td></tr>";
		} else {
	
			$data_label = array( 'vote_average' => JText::_('Vote (avarage)'),
			                     'vote_count'   => JText::_('Vote (count)'),
			                     'comments'       => JText::_('Comments'),
			                     'favorite'       => JText::_('Favorite'),
			                     'hits'           => JText::_('HITs') );
	
			$out[] = '<table class="adminlist" cellspacing="0" >';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			$out[] = '<th>'.JText::_('Value').'</th>';
			$out[] = '<th width="1%">'.$data_label[$criterion].'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			foreach ( $result AS $row ) {
				$slices[$row->name] = $row->amount;
			}
	
			$k = 1;
			$i = 1;
			foreach ( $slices AS $key => $slice )
			{
				$k = 1 - $k;
	
				$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>", $k, $i, $key, $slice);
				$i++;
			}
		}
		$out[] = '</tbody></table>';
		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user_id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
		
	}

	function onGetTotals($name, $params)
	{
		if($name != 'resource13') return;

		$db = JFactory::getDBO();
		$user = &JFactory::getUser();
		$user_id = $params->get('user_id');
		if(!$params->get('user_stick'))
			return;

		$sections  = $params->get( 'sections' );
		$criterion = $params->get( 'criteria' );
		$articles = ( is_array($params->get( 'articles' )) ? $params->get( 'articles' ) : array( $params->get( 'articles' ) ) );
		$field = $params->get( 'field' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );


		if( !$sections ) return;
		if( empty($articles) || in_array( -1, $articles) ) return;
		if( !$field ) return;
		if( !$criterion ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}

		switch( $criterion ) {
			case 'vote_average':
			case 'vote_count':
				$time_criterion = "v.ctime";
				break;
			case 'comments':
				$time_criterion = "co.ctime";
				break;
			case 'favorite':
				$time_criterion = "f.ctime";
				break;
			case 'hits':
				$time_criterion = "h.ctime";
				break;
					
		}
		if ( in_array(0,$articles) ) {
			$sql = " SELECT r.id
			FROM #__js_res_record AS r
			Inner Join #__js_res_record_category AS rc ON r.id = rc.record_id
			WHERE r.published = 1 AND r.user_id ={$user_id}  AND rc.catid IN( ".implode(',',$sections).")";
			
			$db->setQuery($sql);
			$art_ids = $db->loadResultArray();
		} else {
			$art_ids = $articles;
		}	

		switch( $criterion ) {
			case 'vote_average':
				$text = JText::_('voted of selected');
				$sql = "    SELECT sum(v.vote)/count(v.vote) AS amount,count(distinct v.record_id) AS rec_amount, "
				."\n  ( select count(distinct v.user_id) FROM #__js_res_vote AS v where v.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND v.user_id<>0) AS us_amount,"
				."\n ( select count( v.user_id) FROM #__js_res_vote AS v where v.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND v.user_id=0) AS anon_amount "
				."\n  FROM #__js_res_vote AS v 
					Inner Join #__js_res_record AS r ON r.id = v.record_id "
				."\n      WHERE r.published = 1 AND v.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'
				AND r.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
			case 'vote_count':
				$text = JText::_('voted of selected');
				$sql = "    SELECT count(v.id) AS amount,count(distinct v.record_id) AS rec_amount, "
				."\n  ( select count(distinct v.user_id) FROM #__js_res_vote AS v where v.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND v.user_id<>0) AS us_amount,"
				."\n ( select count( v.user_id) FROM #__js_res_vote AS v where v.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND v.user_id=0) AS anon_amount "
				."\n  FROM #__js_res_vote AS v 
					Inner Join #__js_res_record AS r ON r.id = v.record_id "
				."\n      WHERE r.published = 1 AND v.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'
				AND r.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
			case 'comments':
				$text = JText::_('commented of selected');
				$sql = "    SELECT count(co.id) AS amount,count(distinct co.record_id) AS rec_amount, "
				."\n  ( select count(distinct co.user_id) FROM #__js_res_comments AS co where co.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND co.user_id<>0) AS us_amount,"
				."\n ( select count( co.user_id) FROM #__js_res_comments AS co where co.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND co.user_id=0) AS anon_amount "
				."\n  FROM #__js_res_comments AS co 
					Inner Join #__js_res_record AS r ON r.id = co.record_id "
				."\n      WHERE r.published = 1 AND co.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'
				AND r.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
			case 'favorite':
				$text = JText::_('favorited of selected');
				$sql = "    SELECT count(*) AS amount,count(distinct f.record_id) AS rec_amount, "
				."\n  ( select count(distinct f.user_id) FROM #__js_res_favorite AS f where f.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND f.user_id<>0) AS us_amount,"
				."\n ( select count( f.user_id) FROM #__js_res_favorite AS f where f.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND f.user_id=0) AS anon_amount "
				."\n  FROM #__js_res_favorite AS f 
					Inner Join #__js_res_record AS r ON r.id = f.record_id "
				."\n      WHERE r.published = 1 AND f.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'
				AND r.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
			case 'hits':
				$text = JText::_('hited of selected');
				$sql = "    SELECT count(h.id) AS amount,count(distinct h.record_id) AS rec_amount, "
				."\n  ( select count(distinct h.user_id) FROM #__js_res_hits AS h where h.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND h.user_id<>0) AS us_amount,"
				."\n ( select count( h.user_id) FROM #__js_res_hits AS h where h.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}' AND h.user_id=0) AS anon_amount "
				."\n  FROM #__js_res_hits AS h 
					Inner Join #__js_res_record AS r ON r.id = h.record_id "
				."\n      WHERE r.published = 1 AND h.record_id IN('".implode( "', '", $art_ids )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'
				AND r.ctime BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
					
		}

		$db->setQuery( $sql ); 
		$result = $db->loadObject();
		if(!$result->rec_amount) return;
		
		$data_label = array( 'vote_average' => JText::_('Vote (avarage)'),
			                     'vote_count'   => JText::_('Vote (count)'),
			                     'comments'       => JText::_('Comments'),
			                     'favorite'       => JText::_('Favorite'),
			                     'hits'           => JText::_('Hits') );
		
		$totals = array();

		$totals[0]['value'] = count($art_ids).' <i>'.JText::_( 'record(s)').'</i>';
		$totals[0]['text'] = JText::_('Total selected');
		
		$totals[1]['value'] = $result->rec_amount.' <i>'.JText::_( 'record(s)').'</i>';
		$totals[1]['text'] = $text;
		
		$totals[2]['value'] = $result->amount ? $result->amount : 0;
		$totals[2]['text'] = $data_label[$criterion];
		
		$totals[3]['value'] = $result->us_amount + $result->anon_amount;
		$totals[3]['text'] = JText::_('Total').' '.JText::_('users');

		return $totals;
	}
	
	function xajax_loadArticles( &$response, $value, $id, $user) {
		
		if( !$value ) 
			return null;
			
		if ( !is_array($value) )
			$value = array($value);
			
		if( !$user ){
			$user = &JFactory::getUser();
			$user_id = $user->id;
		}else{
			$user_id = $user;
		}
		
		$db = &JFactory::getDBO();
		
		$sql = " SELECT r.id, r.title
		FROM #__js_res_record AS r
		Inner Join #__js_res_record_category AS rc ON r.id = rc.record_id
		WHERE r.published = 1 AND r.user_id ={$user_id}  AND rc.catid IN( ".implode(',',$value).")";
		$sql .= ' ORDER BY r.title';
		
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		
		$option = 'sel.options[sel.length] = new Option("- All -", 0, true, true);';
		
		if ( $result )
			foreach ($result as $val) {
				$option .='sel.options[sel.length] = new Option("'.$val->title.'", "'.$val->id.'");';
			}
		
		$response->script( '
			$("'.$id.'").empty();
			sel = $("'.$id.'");
			'.$option
		);
	}
	
	function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
	
}
?>