<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsresource2 extends JPlugin
{
	function plgAnalyticsresource2( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) {
		if ( $name != 'resource2' ) return;
		
		$data = array( 'amline', 'ampie', 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, $params, &$errors)
	{
		if($name != 'resource2') return;

		global $mainframe;
		
		$type = $params->get('chart_type');

		if( !JComponentHelper::isEnabled('com_resource', true) ) {
			$errors = '<h3>Mighty Resources Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		if( $type == 'ampie' ){
			$objChart->addLabel("<![CDATA[This graph shows relationship of articles by fields values]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Relationship of articles by fields values</b>]]>",15 ,25 , array('text_size' => 16));
		}else{
			$objChart->addLabel("<![CDATA[This graph shows progress of articled by field values]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Progress of articled by field values</b>]]>",90 ,25 , array('text_size' => 16));
		}
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'resource2' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		if( !$report_params->get('user_choose_values') ){
			unset($elements['field_values']);
		}
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';

	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'resource2') return;

		$type = $params->get('chart_type');
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$field   = $params->get( 'field' );
		$field_values = $params->get ( 'field_values', false );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby = $params->get( 'groupby', 'smonth' );

		if( !$field ) return;

		if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(r.ctime)",
			                      "sweek"  => "WEEKOFYEAR(r.ctime)",
			                      "smonth" => "MONTH(r.ctime)",
			                      "syear"  => "YEAR(r.ctime)");
	
			$date_index = Array(  "sday"   => "DATE_FORMAT( r.ctime, '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( r.ctime - INTERVAL WEEKDAY(r.ctime) DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( r.ctime, '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( r.ctime, '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(r.ctime) AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}

		$sql = "    SELECT COUNT(*) AS amount, v.field_value"
		.$sql_dates
		."\n      FROM #__js_res_fields AS f"
		."\n LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id"
		."\n LEFT JOIN #__js_res_record AS r ON r.id = v.record_id"
		."\n     WHERE f.id = ".$field." AND r.ctime BETWEEN '{$from}' AND '{$to}'"
		.($field_values ? ' AND v.field_value IN ("'.implode('","', (!is_array($field_values) ? array($field_values) : $field_values) ).'")' : '');
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND r.user_id = '$user_id'";
		$sql .= "  GROUP BY ".$sql_group." v.field_value"
		."\n  ORDER BY amount DESC"
		;

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		$color_words = array( 'black'   => "#000000",
	                        'navy'    => "#000080",
	                        'gray'    => "#808080",
	                        'blue'    => "#0000FF",
	                        'silver'  => "#C0C0C0",
	                        'aqua'    => "#00FFFF",
	                        'white'   => "#FFFFFF",
	                        'green'   => "#008000",
	                        'red'     => "#FF0000",
	                        'lime'    => "#00FF00",
	                        'fuchsia' => "#FF00FF",
	                        'teal'    => "#008080",
	                        'maroon'  => "#800000",
	                        'yellow'  => "#FFFF00",
	                        'purple'  => "#800080",
	                        'olive'   => "#808000" );
		$colors = array();
		if ( $type != 'ampie')
		{
			foreach ( $result AS $k => $row ) {
				@$sub_values = unserialize( $row->field_value );
				if( is_array( $sub_values )  ) {
					foreach ( $sub_values AS $sub_value ) {
						$sub_value = explode('^', $sub_value);
						if( count($sub_value) > 1)
							$colors[$sub_value[0]] = $sub_value[1];
						$sub_value = $sub_value[0];
						if(!is_array($sub_value)) {
							if( !isset($_result[$sub_value][$row->date_index]) ) $_result[$sub_value][$row->date_index] = 0;
							$_result[$sub_value][$row->date_index]++ ;
						}
					}
				} else {
					$row->field_value = explode('^', $row->field_value);
					if( count($row->field_value) > 1)
						$colors[$row->field_value[0]] = $row->field_value[1];
					$row->field_value = $row->field_value[0];
					if( !isset( $_result[$row->field_value][$row->date_index] ) ) $_result[$row->field_value][$row->date_index] = 0;
					$_result[$row->field_value][$row->date_index] += $row->amount;
				}
			}
			$current_date = $from;
	
			switch ( $groupby ) {
				case "sday":
					$format_series 		= '%Y %d %b';
					break;
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %UW';
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %b';
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y';
					break;
			}
			foreach ( $result AS $row ) {
				$graphs[$row->field_value][$row->date_index] = $row->amount;
			}
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$serie = strftime( $format_series, strtotime( $current_date ) );
				$objChart->addSerie($current_date,$serie);
					if ( $type == 'amline')
					{
						foreach( $graphs as $key => $graph) {
							if( !isset($graphs[$key][$current_date]) ) {
								$graphs[$key][$current_date] = " 0 ";
							}
						}
					}
					$current_date = $this->incrementDate( $current_date, $groupby );
			}
				
			foreach( $graphs as $key => $graph ) {
				$color= isset($colors[$key]) ? $colors[$key] : '';
				if( isset( $color_words[strtolower( $color )] ) ){
					$color = $color_words[strtolower( $color )];
				}
				$objChart->addGraph($key, $key, $graph, array( 'color' => $color,
					'balloon_text' => '<![CDATA[<b>{value}</b> {series} (<i>{percents}%</i>)]]>'
				));
			}
		} else {
			foreach ( $result AS $k => $row ) {
				@$sub_values = unserialize( $row->field_value );
				if( is_array( $sub_values )  ) {
					foreach ( $sub_values AS $sub_value ) {
						$sub_value = explode('^', $sub_value);
						if( count($sub_value) > 1)
							$colors[$sub_value[0]] = $sub_value[1];
						$sub_value = $sub_value[0];
						if( !isset($slices[$sub_value]) ) $slices[$sub_value] = 0;
						$slices[$sub_value]++ ;
					}
				} else {
					$row->field_value = explode('^', $row->field_value);
					if( count($row->field_value) > 1)
						$colors[$row->field_value[0]] = $row->field_value[1];
					$row->field_value = $row->field_value[0];
					if( !isset( $slices[$row->field_value] ) ) $slices[$row->field_value] = 0;
					$slices[$row->field_value] += $row->amount;
				}
			}
			foreach ( $result AS $row ) {
				$slices[$row->field_value] = $row->amount;
			}
	
			$i = 0;
			
			foreach ( $slices AS $k => $slice ) {
				$color= isset($colors[$k]) ? $colors[$k] : '';
				if( isset( $color_words[strtolower( $color )] ) ){
					$color = $color_words[strtolower( $color )];
				}
				$pulout = $i == 0 ? 'true' : 'false';
				$objChart->addSlice($k, $slice, array('color' => $color, 'pull_out' => $pulout, 'alpha' => 95) );
				$i++;
			}
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'resource2') return;

		$type = $params->get('chart_type');
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$field   = $params->get( 'field' );
		$field_values = $params->get ( 'field_values', false );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby = $params->get( 'groupby', 'smonth' );

		$sort_by = $params->get('sort_by', 'amount DESC');
		$limit = $params->get('limit', 0);

		if( !$field ) return;

		if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(r.ctime)",
			                      "sweek"  => "WEEKOFYEAR(r.ctime)",
			                      "smonth" => "MONTH(r.ctime)",
			                      "syear"  => "YEAR(r.ctime)");
	
			$date_index = Array(  "sday"   => "DATE_FORMAT( r.ctime, '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( r.ctime - INTERVAL WEEKDAY(r.ctime) DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( r.ctime, '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( r.ctime, '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(r.ctime) AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		$sql = "    SELECT COUNT(*) AS amount, v.field_value"
		.$sql_dates
		."\n      FROM #__js_res_fields AS f"
		."\n LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id"
		."\n LEFT JOIN #__js_res_record AS r ON r.id = v.record_id"
		."\n     WHERE f.id = ".$field." AND r.ctime BETWEEN '{$from}' AND '{$to}'"
		.($field_values ? ' AND v.field_value IN ("'.implode('","', (!is_array($field_values)?array($field_values):$field_values) ).'")' : '');
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND r.user_id = '$user_id'";
		$sql .= "  GROUP BY ".$sql_group." v.field_value"
		."\n  ORDER BY ".$sort_by
		;
		if($limit)
			$sql .= " LIMIT 0, $limit";
		
		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		$_result = array();

		if ( $type != 'ampie')
		{
			foreach ( $result AS $k => $row ) {
				@$sub_values = unserialize( $row->field_value );
				if( is_array( $sub_values )  ) {
					foreach ( $sub_values AS $sub_value ) {
						$sub_value = explode('^', $sub_value);
						$sub_value = $sub_value[0];
						if( !is_array( $sub_value )  ) {
							if( !isset($_result[$sub_value][$row->date_index]) ) $_result[$sub_value][$row->date_index] = 0;
							$_result[$sub_value][$row->date_index]++ ;
						}
					}
				} else {
					$row->field_value = explode('^', $row->field_value);
					$row->field_value = $row->field_value[0];
					if( !isset( $_result[$row->field_value][$row->date_index] ) ) $_result[$row->field_value][$row->date_index] = 0;
					$_result[$row->field_value][$row->date_index] += $row->amount;
				}
			}
			foreach ( $_result AS $key => $row ) {
				foreach( $row AS $date => $amount ) {
					$graphs[$key][$date] = $amount;
				}
			}

			$k     = 0;
			$total = 0;
	
			$out[] = '<table class="adminlist" cellspacing="0">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			foreach( $graphs as $key => $graph) {
				$out[] = '<th class="title">'.$key.'</th>';
			}
			$out[] = '<th width="1%">'.JText::_('Date').'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			$current_date = $from;
	
			switch ( $groupby ) {
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
			}
	
			$i = 0;
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$i++;
				if ( $limit && $i > $limit ) break;
				$k = 1 - $k;
				$out[] = "<tr class='row".$k."'>";
				$out[] = "<td>".$i."</td>";
				foreach( $graphs as $key => $graph) {
					if( !isset($graphs[$key][$current_date]) ) {
						$graphs[$key][$current_date] = 0;
					}
					if( !isset($graphs[$key]['total']) ){
						$graphs[$key]['total'] = 0;
					}
					$graphs[$key]['total'] += $graphs[$key][$current_date];
	
					$out[] = "<td>".$graphs[$key][$current_date]."</td>";
	
				}
	
				$out[] = "<td>".$current_date."</td>";
				$out[] = "</tr>";
	
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
	
			$out[] = "<tr class='row0><td><big><b>".JText::_('Total')."</b></big></td>";
			foreach( $graphs as $key => $graph) {
				$out[] = "<td><big><b>".$graphs[$key]['total']."<b></big></td>";
			}
			$out[] = "<td></td></tr>";
		} else {
			$out[] = '<table class="adminlist">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			$out[] = '<th class="title">'.JText::_('Value').'</th>';
			$out[] = '<th width="1%">'.JText::_('Records').'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
		
			foreach ( $result AS $k => $row ) {
				@$sub_values = unserialize( $row->field_value );
				if( is_array( $sub_values )  ) {
					foreach ( $sub_values AS $sub_value ) {
						$sub_value = explode('^', $sub_value);
						$sub_value = $sub_value[0];
						if( !isset($slices[$sub_value]) ) $slices[$sub_value] = 0;
						$slices[$sub_value]++ ;
					}
				} else {
					$row->field_value = explode('^', $row->field_value);
					$row->field_value = $row->field_value[0];
					if( !isset( $slices[$row->field_value] ) ) $slices[$row->field_value] = 0;
					$slices[$row->field_value] += $row->amount;
				}
			}
			$k = 1;
			$i = 1;
			$current_total      = 0;
			foreach ( $slices AS $p => $slice )
			{
				$current_total += $slice;
	
				$k = 1 - $k;
	
				$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
				$k, $i, $p, $slice );
				$i++;
			}
			$out[] = sprintf( "<tr class='row%d'><td></td><td nowrap><big><b>%s</b></big></td><td align='right'><big><b>%s</b></big></td></tr>",
				0, JText::_('Total'), $current_total );
		}

		$out[] = '</tbody></table>';
		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'resource2') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');
		$field_values = $params->get ( 'field_values', false );
		$field   = $params->get( 'field' );
		$from    = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to      = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );

		if( !$field ) return;

		$sql = "    SELECT COUNT(*) AS amount"
		."\n FROM #__js_res_fields AS f"
		."\n LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id"
		."\n LEFT JOIN #__js_res_record AS r ON r.id = v.record_id"
		."\n     WHERE f.id = ".$field." AND r.ctime BETWEEN '{$from}' AND '{$to}'"
		.($field_values ? ' AND v.field_value IN ("'.implode('","', (!is_array($field_values) ? array($field_values) : $field_values) ).'")' : '');
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND r.user_id = '$user_id'";

		$db->setQuery( $sql );
		$result = $db->loadResult();

		if( !$result ) return;

		$sql2 = "    SELECT COUNT(*)"
		."\n FROM #__js_res_fields AS f"
		."\n LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id"
		."\n LEFT JOIN #__js_res_record AS r ON r.id = v.record_id"
		."\n     WHERE f.id = ".$field;
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql2 .= " AND r.user_id = '$user_id'";
		$db->setQuery( $sql2 );
		$dbtotal_records = $db->loadResult();

		if( !$result || !$dbtotal_records) return;
		$totals = array();

		$totals[0]['value'] = $dbtotal_records.' <i>'.JText::_( 'records').'</i>' ;
		$totals[0]['text'] =  JText::_( 'Total in DB' );

		$totals[1]['value'] = $result.' <i>'.JText::_( 'current records').'</i>' ;
		$totals[1]['text'] = round($result / ($dbtotal_records/100), 1).'%</b></big> '.JText::_( 'of all records ' );

		return $totals;
	}
	
	function xajax_loadFieldValues( &$response, $value, $id, $rep_id) {
		
		if( !$value ) 
			return null;
			
		if ( !is_array($value) )
			$value = array($value);
			
		$db = &JFactory::getDBO();
		$user = &JFactory::getUser();
		
		$report = &JTable::getInstance('Report', 'Report');
		$report->load(array_pop($rep_id));
		$params = new JParameter($report->params);
		
		$sql = "SELECT DISTINCT rv.field_value
		FROM #__js_res_record_values AS rv
		Inner Join #__js_res_record AS r ON r.id = rv.record_id
		WHERE r.published = 1 AND rv.field_id = ".array_pop($value);
		
		if ( $params->get('user_stick') )
		    $sql .= " AND r.user_id = ".$user->id;
		
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		$option = '';
		if ( $result ) {
			foreach ($result as $val) {
				$parts = explode('^',$val->field_value);
				$option .='sel.options[sel.length] = new Option("'.$parts[0].'", "'.$val->field_value.'",false,true);';
			}
		}
		
		$response->script( '
			$("'.$id.'").empty();
			sel = $("'.$id.'");
			'.$option
		);
	}
	
	function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}

}
?>