<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsresource5 extends JPlugin
{
	function plgAnalyticsresource5( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) 
	{
		if ( $name != 'resource5' ) return;
		
		$data = array( 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, $params, &$errors)
	{
		if($name != 'resource5') return;

		global $mainframe;

		if( !JComponentHelper::isEnabled('com_resource', true) ) {
			$errors = '<h3>Mighty Resources Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->setConfig('column.data_labels','<![CDATA[{value}]]>');
		$objChart->addLabel("<![CDATA[<b>Top Authors</b>]]>",15 ,25 , array('text_size' => 16));
		
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'resource5' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label" '.($key == 'category' ? 'valign="top"' : '').'><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'resource5') return;

		$type = $params->get('chart_type');
		
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$categories = $params->get( 'cats' );
		$max        = $params->get( 'max' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$sort_by = $params->get('sort_by', 'amount DESC');
		if( !$categories ) return;

		if( !is_array( $categories ) ) {
			$categories = array( $categories );
		}

		$sql = "     SELECT COUNT(*) AS amount, u.username, u.id"
		."\n  FROM      #__users                  AS u"
		."\n  LEFT JOIN #__js_res_record          AS r  ON r.user_id = u.id"
		."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
		."\n INNER JOIN #__js_res_category        AS c  ON c.id = rc.catid"
		."\n      WHERE u.block = 0 AND r.published = 1 AND c.id IN('".implode( "', '", $categories )."') AND r.ctime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql .= " AND r.user_id = '$user_id'";
		$sql .= " GROUP BY u.id"
		."\n   ORDER BY ".$sort_by
		."\n      limit 0, ".$max
		;

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		foreach ( $result AS $row ) {
			$objChart->addSerie($row->id,$row->username);
			$objChart->addGraph($row->id, $row->username, array($row->id => $row->amount), array( 
					'balloon_text' => '<![CDATA[<b>{value}</b><i>resord(s)</i> {series}]]>'
				));
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'resource5') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = 0;
		if($params->get('user_stick'))
		{
			$user_id = $user->id;
		}
		if($user->gid == 25) $user_id = JRequest::getInt('user_id', $user_id);


		$categories = $params->get( 'cats' );
		$max        = $params->get( 'max' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);


		if( !$categories ) return;
		if( !$max ) return;

		if( !is_array( $categories ) ) {
			$categories = array( $categories );
		}

		$sql = "     SELECT COUNT(*) AS amount, u.username, u.name, u.id"
		."\n  FROM      #__users                  AS u"
		."\n  LEFT JOIN #__js_res_record          AS r  ON r.user_id = u.id"
		."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
		."\n INNER JOIN #__js_res_category        AS c  ON c.id = rc.catid"
		."\n      WHERE u.block = 0 AND r.published = 1 AND c.id IN('".implode( "', '", $categories )."') AND r.ctime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND r.user_id = '$user_id'";
		$sql .= "  GROUP BY u.id"
		."\n   ORDER BY ".($sort_by ? $sort_by : "amount DESC")
		."\n      limit 0, ".($limit ? $limit : $max)
		;

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		$k                  = 0;
		$current_total      = 0;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Author').'</th>';
		$out[] = '<th width="1%">'.JText::_('Records').'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		foreach ( $result AS $row ) {
			$slices[$row->username]['name'] = $row->name;
			$slices[$row->username]['amount'] = $row->amount;
		}

		$k = 1;
		$i = 1;
		foreach ( $slices AS $key => $slice ) {

			$current_total += $slice['amount'];

			$k = 1 - $k;

			$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
			$k, $i, '<b>'.$key.'</b> ('.$slice['name'].')', $slice['amount']
			);
			$i++;
		}

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
		
	}

	function onGetTotals( $name, $params)
	{
		if($name != 'resource5') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$categories = $params->get( 'cats' );
		$max        = $params->get( 'max' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);


		if( !$categories ) return;
		if( !$max ) return;

		if( !is_array( $categories ) ) {
			$categories = array( $categories );
		}

		$sql = "     SELECT COUNT(*) AS amount, u.username"
		."\n  FROM      #__users                  AS u"
		."\n  LEFT JOIN #__js_res_record          AS r  ON r.user_id = u.id"
		."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id"
		."\n INNER JOIN #__js_res_category        AS c  ON c.id = rc.catid"
		."\n      WHERE u.block = 0 AND r.published = 1 AND c.id IN('".implode( "', '", $categories )."') AND r.ctime BETWEEN '{$from}' AND '{$to}'";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND r.user_id = '$user_id'";
		$sql .= "  GROUP BY u.id"
		."\n   ORDER BY ".($sort_by ? $sort_by : "amount DESC")
		."\n      limit 0, 1"
		;

		$db->setQuery( $sql );
		$result = $db->loadObject();

		$sql2 = "SELECT COUNT(*) FROM #__js_res_record r
		LEFT JOIN #__js_res_record_category rc ON r.id = rc.record_id
		WHERE rc.catid IN ( ".implode(', ', $categories)." ) AND r.published = 1 ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql2 .= " AND r.user_id = '$user_id'";
		
		$db->setQuery( $sql2 );
		$dbtotal_records = $db->loadResult();
		
		$sql = "SELECT if(count(id) < 1, 0, count(id) )AS amount FROM #__js_res_record WHERE published = 1 ";
		$db->setQuery($sql);
		$total_records = $db->loadResult();
		
		if( !$result || !( $dbtotal_records >= 0 ) ) return;

		$totals = array();

		$totals[0]['value'] = $total_records.' <i>'.JText::_( 'record(s)').'</i>' ;
		$totals[0]['text'] =  JText::_( 'Total in DB' );
		
		$totals[1]['value'] = $dbtotal_records.' <i><b>'.JText::_( 'current record(s)' ).'</b></i>';
		$totals[1]['text'] = round($dbtotal_records * 100 / $total_records, 1).'% '.JText::_('of all records');
		
		$totals[2]['value'] = $result->amount.' <i>'.JText::_( 'record(s)').'</i>' ;
		$totals[2]['text'] =  JText::_( 'created by' ).' <b>'.ucfirst($result->username).'</b>';

		return $totals;

	}
}
?>