<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsresource6 extends JPlugin
{
	function plgAnalyticsresource6( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onGetChartTypes(&$data, $name) 
	{
		if ( $name != 'resource6' ) return;
		
		$data = array( 'amline', 'ampie', 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, $params, &$errors)
	{
		if($name != 'resource6') return;

		global $mainframe;
		
		$type = $params->get('chart_type');

		if( !JComponentHelper::isEnabled('com_resource', true) ) {
			$errors = '<h3>Mighty Resources Component Not Exists or Not Enabled<h3>';
			return;
		}

		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");	
		if( $type == 'ampie' ){
			$objChart->addLabel("<![CDATA[This graph shows section articles relationship]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Section articles relationship</b>]]>",15 ,25 , array('text_size' => 16));
		}else{
			$objChart->addLabel("<![CDATA[This graph shows section articles progress]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Section articles progress</b>]]>",90 ,25 , array('text_size' => 16));
		}

	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'resource6' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label" '.($key == 'category' ? 'valign="top"' : '').'><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}
			$form .= '</tr>';
		}
		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{
		if($name != 'resource6') return;

		$type = $params->get('chart_type');
		
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$sections  = $params->get( 'sections' );
		$criterion = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );

		if( !$sections ) return;
		if( !$criterion ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}

		switch( $criterion ) {
			case 'rating_average':
			case 'rating_count':
				$time_criterion = "v.ctime";
				break;
			case 'comments':
				$time_criterion = "co.ctime";
				break;
			case 'favorite':
				$time_criterion = "f.ctime";
				break;
			case 'hits':
				$time_criterion = "h.ctime";
				break;
					
		}

		if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(".$time_criterion.")",
			                      "sweek"  => "WEEKOFYEAR(".$time_criterion.")",
			                      "smonth" => "MONTH(".$time_criterion.")",
			                      "syear"  => "YEAR(".$time_criterion.")");
	
			$date_index = Array(  "sday"   => "DATE_FORMAT( ".$time_criterion.", '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( ".$time_criterion." - INTERVAL WEEKDAY(".$time_criterion.") DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( ".$time_criterion.", '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( ".$time_criterion.", '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(".$time_criterion.") AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		switch( $criterion ) {
			case 'rating_average':
				$sql = "     SELECT (SUM(v.vote)/COUNT(*))   AS amount, if(s.title <> '', s.title,s.name) AS name"
				.$sql_dates
				."\n  FROM      #__js_res_category        AS s"
				."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n  WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY ".$sql_group." s.id"
				."\n   ORDER BY amount DESC"
				;
				break;
			case 'rating_count':
			   $sql = "     SELECT COUNT(distinct v.id)   AS amount, if(s.title <> '', s.title,s.name) AS name"
			   .$sql_dates
			   ."\n  FROM      #__js_res_category        AS s"
			   ."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
			   ."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
			   ."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
			   ."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
			   ."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
			   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			   $sql .= " AND r.user_id = '$user_id'";
			   $sql .= " GROUP BY ".$sql_group." s.id"
			   ."\n   ORDER BY amount DESC"
			   ;
			   break;
			case 'comments':
			    $sql = "     SELECT COUNT(distinct co.id)  AS amount, if(s.title <> '', s.title,s.name) AS name"
			    .$sql_dates
			    ."\n  FROM      #__js_res_category        AS s"
			    ."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
			    ."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
			    ."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
			    ."\n  LEFT JOIN #__js_res_comments        AS co ON co.record_id = r.id"
			    ."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
			    if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			    	$sql .= " AND r.user_id = '$user_id'";
			    $sql .= " GROUP BY ".$sql_group." s.id"
			    ."\n   ORDER BY amount DESC"
			    ;
			    break;
			case 'favorite':
				$sql = "     SELECT COUNT(*)  AS amount, if(s.title <> '', s.title,s.name) AS name"
				.$sql_dates
				."\n  FROM      #__js_res_category        AS s"
				."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_favorite        AS f  ON f.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY ".$sql_group." s.id"
				."\n   ORDER BY amount DESC"
				;
					break;
			case 'hits':
				$sql = "     SELECT COUNT(distinct h.id)  AS amount, if(s.title <> '', s.title,s.name) AS name"
				.$sql_dates
				."\n  FROM      #__js_res_category        AS s"
				."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_hits            AS h  ON h.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY ".$sql_group." s.id"
				."\n   ORDER BY amount DESC"
				;
				break;

		}

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

		if ( $type != 'ampie')
		{
			$current_date = $from;

			switch ( $groupby ) {
				case "sday":
					$format_series 		= '%Y %d %b';
					break;
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %UW';
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %b';
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y';
					break;
			}
			foreach ( $result AS $row ) {
				$graphs[$row->name][$row->date_index] = $row->amount;
			}
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$serie = strftime( $format_series, strtotime( $current_date ) );
				$objChart->addSerie($current_date,$serie);
					if ( $type == 'amline')
					{
						foreach( $graphs as $key => $graph) {
							if( !isset($graphs[$key][$current_date]) ) {
								$graphs[$key][$current_date] = " 0 ";
							}
						}
					}
					$current_date = $this->incrementDate( $current_date, $groupby );
			}
			
			foreach( $graphs as $key => $graph ) {
				$objChart->addGraph($key, $key, $graph, array( 
					'balloon_text' => '<![CDATA[<b>{value}</b><i>resord(s)</i> {series}]]>'
				));
			} 
		} else {
			foreach ( $result AS $row ) {
				$slices[$row->name] = $row->amount;
			}
	
			$i = 0;
			foreach ( $slices AS $k => $slice ) {
	
				$pulout = $i == 0 ? 'true' : 'false';
				$objChart->addSlice($k, $slice, array( 'pull_out' => $pulout, 'alpha' => 95) );
				$i++;
			}
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'resource6') return;
	
		$type = $params->get('chart_type');
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$sections  = $params->get( 'sections' );
		$criterion = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );
		$sort_by = $params->get('sort_by', 'amount DESC');
		$limit = $params->get('limit', 0);


		if( !$sections ) return;
		if( !$criterion ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}

		switch( $criterion ) {
			case 'rating_average':
			case 'rating_count':
				$time_criterion = "v.ctime";
				break;
			case 'comments':
				$time_criterion = "co.ctime";
				break;
			case 'favorite':
				$time_criterion = "f.ctime";
				break;
			case 'hits':
				$time_criterion = "h.ctime";
				break;
		}

		if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(".$time_criterion.")",
			                      "sweek"  => "WEEKOFYEAR(".$time_criterion.")",
			                      "smonth" => "MONTH(".$time_criterion.")",
			                      "syear"  => "YEAR(".$time_criterion.")");
	
			$date_index = Array(  "sday"   => "DATE_FORMAT( ".$time_criterion.", '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( ".$time_criterion." - INTERVAL WEEKDAY(".$time_criterion.") DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( ".$time_criterion.", '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( ".$time_criterion.", '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(".$time_criterion.") AS c_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'c_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		switch( $criterion ) {
			case 'rating_average':
			   $sql = "     SELECT (SUM(v.vote)/COUNT(*))   AS amount, if(s.title <> '', s.title,s.name) AS name"
			   .$sql_dates
			   ."\n  FROM      #__js_res_category        AS s"
			   ."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
			   ."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
			   ."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
			   ."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
			   ."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
			   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			   $sql .= " AND r.user_id = '$user_id'";
			   $sql .= " GROUP BY ".$sql_group." s.id"
			   ."\n   ORDER BY ".$sort_by
			   ;
			   break;
			case 'rating_count':
			   $sql = "     SELECT COUNT(*) AS amount, if(s.title <> '', s.title,s.name) AS name"
			   .$sql_dates
			   ."\n  FROM      #__js_res_category        AS s"
			   ."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
			   ."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
			   ."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
			   ."\n  LEFT JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
			   ."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
			   if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			   		$sql .= " AND r.user_id = '$user_id'";
			   $sql .= " GROUP BY ".$sql_group." s.id"
			   ."\n  ORDER BY ".$sort_by
			   ;
			   break;
			case 'comments':
			     $sql = "     SELECT COUNT(*) AS amount, if(s.title <> '', s.title,s.name) AS name"
			     .$sql_dates
			     ."\n  FROM      #__js_res_category        AS s"
			     ."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
			     ."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
			     ."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
			     ."\n  LEFT JOIN #__js_res_comments        AS co ON co.record_id = r.id"
			     ."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
			     if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			     	$sql .= " AND r.user_id = '$user_id'";
			     $sql .= " GROUP BY ".$sql_group." s.id"
			     ."\n   ORDER BY ".$sort_by
			     ;
			     break;
			case 'favorite':
				$sql = "     SELECT COUNT(distinct h.id)  AS amount, if(s.title <> '', s.title,s.name) AS name"
				.$sql_dates
				."\n  FROM      #__js_res_category        AS s"
				."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_favorite        AS f  ON f.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY ".$sql_group." s.id"
				."\n ORDER BY ".$sort_by
				;
				break;
			case 'hits':
				$sql = "     SELECT COUNT(distinct h.id) AS amount, if(s.title <> '', s.title,s.name) AS name"
				.$sql_dates
				."\n  FROM      #__js_res_category        AS s"
				."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  LEFT JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  LEFT JOIN #__js_res_hits            AS h  ON h.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql .= " GROUP BY ".$sql_group." s.id"
				."\n  ORDER BY ".$sort_by
				;
				break;
					
		}
		if($limit)
			$sql .= " LIMIT 0, $limit";

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;
		
		if ( $type != 'ampie')
		{
			foreach ( $result AS $row ) {
				$graphs[$row->name][$row->date_index] = $row->amount;
			}
	
			$k     = 0;
			$total = 0;
	
			$out[] = '<table class="adminlist" cellspacing="0">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			foreach( $graphs as $key => $graph) {
				$out[] = '<th class="title">'.$key.'</th>';
			}
			$out[] = '<th width="1%">'.JText::_('Date').'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			$current_date = $from;
				
			switch ( $groupby ) {
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					break;
			}
	
			$i = 0;
			while ( strtotime( $current_date ) <= strtotime( $to )) {
				$i++;
				if ( $limit && $i > $limit ) break;
				$k = 1 - $k;
				$out[] = "<tr class='row".$k."'>";
				$out[] = "<td>".$i."</td>";
				foreach( $graphs as $key => $graph) {
					if( !isset($graphs[$key][$current_date]) ) {
						$graphs[$key][$current_date] = 0;
					}
					if( !isset($graphs[$key]['total']) ){
						$graphs[$key]['total'] = 0;
						$graphs[$key]['count'] = 0;
					}
	
					if( $graphs[$key][$current_date] > 0 ) {
						$graphs[$key]['total'] += $graphs[$key][$current_date];
						$graphs[$key]['count'] ++;
					}
	
					$out[] = "<td>".$graphs[$key][$current_date]."</td>";
	
				}
	
				$out[] = "<td>".$current_date."</td>";
				$out[] = "</tr>";
	
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
	
			$out[] = "<tr class='row".$k."'><td><big><b>".JText::_('Total')."</b></big></td>";
	
			foreach( $graphs as $key => $graph) {
				$out[] = "<td><big><b>".round($criterion == 'rating_average' ? ( $graphs[$key]['count'] >0 ? $graphs[$key]['total'] / $graphs[$key]['count'] : 0 ): $graphs[$key]['total'], 2 )."<b></big></td>";
			}
			$out[] = "<td></td></tr>";
		} else {
			$k                  = 0;
			$current_total      = 0;
	
			$data_label = array( 'rating_average' => JText::_('Rating (avarage)'),
			                     'rating_count'   => JText::_('Rating (count)'),
			                     'comments'       => JText::_('Comments'),
			                     'favorite'       => JText::_('Favorite'),
			                     'hits'           => JText::_('Hits') );
	
			$out[] = '<table class="adminlist" cellspacing="0">';
			$out[] = '<thead>';
			$out[] = '<tr>';
			$out[] = '<th width="1%">#</th>';
			$out[] = '<th class="title">'.JText::_('Section').'</th>';
			$out[] = '<th width="1%">'.$data_label[$criterion].'</th>';
			$out[] = '</tr>';
			$out[] = '</thead>';
			$out[] = '<tbody>';
	
			foreach ( $result AS $row ) {
				$slices[$row->name] = $row->amount;
			}
	
			$k = 1;
			$i = 1;
			foreach ( $slices AS $key => $slice )
			{
				$current_total += $slice;
				$k = 1 - $k;
	
				$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>", $k, $i, $key, $slice);
				$i++;
			}
			$out[] = sprintf( "<tr class='row%d'><td></td><td nowrap><big><b>%s</b></big></td><td align='right'><big><b>%s</b></big></td></tr>",
				0, JText::_('Total'), $current_total );
		}

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
		
	}

	function onGetTotals($name, $params)
	{
		if($name != 'resource6') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$sections  = $params->get( 'sections' );
		$criterion = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$groupby   = $params->get( 'groupby', 'smonth' );


		if( !$sections ) return;
		if( !$criterion ) return;

		if( !is_array( $sections ) ) {
			$sections = array( $sections );
		}

		switch( $criterion ) {
			case 'rating_average':
			case 'rating_count':
				$time_criterion = "v.ctime";
				break;
			case 'comments':
				$time_criterion = "co.ctime";
				break;
			case 'favorite':
				$time_criterion = "f.ctime";
				break;
			case 'hits':
				$time_criterion = "h.ctime";
				break;
					
		}
		
		switch( $criterion ) {
			case 'rating_average':
				$text = JText::_('rating (average)');
				$sql = "     SELECT (SUM(v.vote)/COUNT(v.id))   AS amount, count(distinct r.id) AS rec_count"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
					
				$sql_total = "     SELECT (SUM(v.vote)/COUNT(v.id))   AS amount "
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
			case 'rating_count':
				$text = JText::_('rating (count)');
				$sql = "     SELECT COUNT(distinct v.id) AS amount, count(distinct r.id) AS rec_count"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql_total = "     SELECT COUNT(distinct v.id) AS amount"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_vote            AS v  ON v.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
			case 'comments':
				$text = JText::_('comments');
				$sql = "     SELECT COUNT(distinct co.id) AS amount, count(distinct r.id) AS rec_count"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_comments        AS co ON co.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql_total = "     SELECT COUNT(distinct co.id) AS amount"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_comments        AS co ON co.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
			case 'favorite':
				$text = JText::_('favorite');
				$sql = "     SELECT COUNT(*)  AS amount, count(distinct r.id) AS rec_count"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_favorite        AS f  ON f.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql_total = "     SELECT COUNT(*)  AS amount"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_favorite        AS f  ON f.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
			case 'hits':
				$text = JText::_('hits');
				$sql = "     SELECT COUNT(distinct h.id) AS amount, count(distinct r.id) AS rec_count"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_hits            AS h  ON h.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				$sql_total = "     SELECT COUNT(distinct h.id) AS amount"
				."\n  FROM      #__js_res_category        AS s"
				."\n  INNER JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
				."\n  INNER JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
				."\n  INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
				."\n  INNER JOIN #__js_res_hits            AS h  ON h.record_id = r.id"
				."\n      WHERE s.id IN('".implode( "', '", $sections )."')";
				if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
					$sql .= " AND r.user_id = '$user_id'";
				break;
					
		}

		$db->setQuery( $sql ); 
		$result = $db->loadObject();
		if(!$result->amount) return;
		
		$db->setQuery( $sql_total ); 
		$total = $db->loadResult();
		
		$sql2 = "     SELECT COUNT(*)                 AS amount"
		."\n  FROM      #__js_res_category        AS s"
		."\n  LEFT JOIN #__js_res_category        AS c  ON (s.id = c.section_id OR s.id = c.id) AND c.published = 1"
		."\n  LEFT JOIN #__js_res_record_category AS rc ON rc.catid = c.id"
		."\n INNER JOIN #__js_res_record          AS r  ON r.id = rc.record_id AND r.published = 1"
		."\n      WHERE s.id IN('".implode( "', '", $sections )."') ";
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
			$sql2 .= " AND r.user_id = '$user_id'";
		$db->setQuery( $sql2 );
		$dbtotal_records = $db->loadResult();
		
		$totals = array();

		$totals[0]['value'] = $dbtotal_records.' <i>'.JText::_( 'records').'</i>';
		$totals[0]['text'] = JText::_('Total in DB');
		
		$totals[1]['value'] = $result->rec_count.' <i><b>'.JText::_( 'current record(s)' ).'</b></i>';
		$totals[1]['text'] = round($result->rec_count * 100 / $dbtotal_records, 1).'% '.JText::_('of all records');
		
		$totals[2]['value'] = $total;
		$totals[2]['text'] = JText::_('Total').' '.$text;
		
		$totals[3]['value'] = $result->amount.' <i><b>'.JText::_( 'current' ).' '.$text.'</b></i>';
		$totals[3]['text'] = round($result->amount * 100 / $total, 1).'% '.JText::_('of all').' '.$text;

		return $totals;
	}
	
	function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
}
?>